﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Collections.ObjectModel;
using System.ComponentModel;

namespace IG_BasicData
{
    public class GetBasicData
    {  
        private static ObservableCollection<BasicData>  basicData;

        private static ObservableCollection<BasicData> LoadBasicDataCollection()
        {
            string[] Catgs = { "Condiments",  "Confections" ,  "DiaryProducts", "Grains",  "Meat", "Produce",  "Seafood" };
            string[] groceries = { "Pepper", "Salt", "Pie", "Cake", "Pudding", 
                                     "Milk", "Butter", "Orange Juice",
                                     "Whole Wheat Bread", "White Bread", "Raisin Bread", "Muffins", 
                                     "Pork", "Beef", "Chicken", "Lamb","Ham", 
                                     "Lettuce", "Cucumber", "Carrots", "Beets", "Squash",
                                     "Bass", "Sole", "Lobster", "Clams", "Salmon" };
            string[] cities = { "Little Town", "Town", "Big Town", "City", "Big City" };
            string[] states = { "New York", "New Jersey", "Pennsylvania", "Massechusetts", "Connecticut", "Rhode Island", "Vermont", "New Hampshire" };

            Random r = new Random();           
            bool[] bs = {true, false};

            basicData = new ObservableCollection<BasicData>();
            string department = "Groceries";
            for (int i = 1; i < 11; i++)
            {                
                basicData.Add( new BasicData( i.ToString(),
                    groceries[r.Next(0, 27)],
                    department,
                    i * 3.73, 
                    bs[r.Next(0, 2)],
                    System.DateTime.Today.AddHours(i),
                    Catgs[r.Next(0,7)],                  
                    cities[r.Next(0, 4)],
                    states[r.Next(0, 7)]
                    )
                    );
            };
            return basicData;            
        }


        public ObservableCollection<BasicData> BasicGridData
        {
            get {
                if (basicData == null)
                    { LoadBasicDataCollection();  }

                return basicData;
            }
        }
    }

    public class BasicData : INotifyPropertyChanged
    {
        string id;
        string name;
        string city;
        string state;
        string category;
        string department;
        double rate;
        bool isineditmode;
        DateTime date;
      

        public BasicData()
        {
        }

        public BasicData(string id, string name, string department, double rate, bool isineditmode, DateTime date,  String category, string city,string state)
        {
            this.ID = id;
            this.Name = name;
            this.Department = department;
            this.Rate = rate;
            this.IsInEditMode = isineditmode;
         
            this.Date = date;
            this.Category = category;           

            this.City = city;
            this.State = state;
            
        }

        public string ID
        {
            get { return id; }
            set
            {
                if (id != value)
                {
                    id = value;
                    OnPropertyChanged("ID");
                }
            }
        }
        
        public string Name
        {
            get { return name; }
            set
            {
                if (name != value)
                {
                    name = value;
                    OnPropertyChanged("Name");
                }
            }
        }
        public string City
        {
            get { return city; }
            set
            {
                if (city != value)
                {
                    city = value;
                    OnPropertyChanged("City");
                }
            }
        }
        public string State
        {
            get { return state; }
            set
            {
                if (state != value)
                {
                    state = value;
                    OnPropertyChanged("State");
                }
            }
        }

        public string Category
        {
            get { return category; }
            set
            {
                if (category != value)
                {
                    category = value;
                    OnPropertyChanged("Category");
                }
            }
        }
        public string Department
        {
            get { return department; }
            set
            {
                if (department != value)
                {
                    department = value;
                    OnPropertyChanged("Department");
                }
            }
        }

        public double Rate
        {
            get { return rate; }
            set
            {
                if (rate != value)
                {
                    rate = value;
                    OnPropertyChanged("Rate");
                }
            }
        }
        public bool IsInEditMode
        {
            get { return isineditmode; }
            set
            {
                if (isineditmode != value)
                {
                    isineditmode = value;
                    OnPropertyChanged("IsInEditMode");
                }
            }
        }    

        public DateTime Date
        {
            get { return date; }
            set
            {
                if (date != value)
                {
                    date = value;
                    OnPropertyChanged("Date");
                }
            }
        }      
       

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        private void OnPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }
        #endregion
    }

  
    
}
